/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* 如果要在程序中使用此代码,请在程序中注明使用了STC的资料及程序        */
/*---------------------------------------------------------------------*/

#include "stc.h"
#include "uart.h"
#include "usb.h"
#include "util.h"
#include "usb_req_class.h"

//#include <stdio.h>
#include <string.h>
#include "EEPROM.h"

BOOL UartBusy;

void uart_init()
{
    P_SW2 &= ~0x01;     //UART2 switch to: 0: P1.0 P1.1

    P1M0 &= ~0x03;      //P1.0,P1.1设置为准双向模式
    P1M1 &= ~0x03;

    S2CON = 0x50;
    T2L = BR(115200);
    T2H = BR(115200) >> 8;
    AUXR |= 0x14;	      //定时器2时钟1T模式,开始计时
    IE2  |= 1;            //允许中断

    LineCoding.dwDTERate = REV4(115200);
    LineCoding.bCharFormat = 0;
    LineCoding.bParityType = 0;
    LineCoding.bDataBits = 8;
}

void uart2_isr() interrupt UART2_VECTOR
{
    if((S2CON & 2) != 0)
    {
        S2CON &= ~2;    //Clear Tx flag
        UartBusy = 0;
    }

    if((S2CON & 1) != 0)
    {
        S2CON &= ~1;    //Clear Rx flag
        TxBuffer[TxWptr++] = S2BUF;
    }
}

void uart_set_parity(BYTE parity)
{
    switch (parity)
    {
    case NONE_PARITY:
        S2CON = 0x50;
        break;
    case ODD_PARITY:
    case EVEN_PARITY:
    case MARK_PARITY:
        S2CON = 0xda;
        break;
    case SPACE_PARITY:
        S2CON = 0xd2;
        break;
    }
}

void uart_set_baud(DWORD baud)
{
    WORD temp;

    temp = (WORD)BR(baud);
    T2L = temp;
    T2H = temp >> 8;
}

void USB_CDC_send(BYTE USB_CDC_send_data[100]){
    BYTE i;
    BYTE len;
    IE2 &= ~0x80;   //EUSB = 0;
    UsbInBusy = 1;
    usb_write_reg(INDEX, 3);
    i = 0;
    len = strlen(USB_CDC_send_data);
    for(i=0; i<len; i++){
        usb_write_reg(FIFO3, USB_CDC_send_data[i]);
    }
    usb_write_reg(INCSR1, INIPRDY);
    IE2 |= 0x80;    //EUSB = 1;		
}

void uart_polling(){
    BYTE cnt;
    BYTE xdata rx_data[50];

    if (DeviceState != DEVSTATE_CONFIGURED)
        return;

    //如果接收到了数据
    if(!UsbInBusy && (RxRptr != RxWptr)){
        //把收到的数据放在rx_data
        cnt = 0;
        while (RxRptr != RxWptr){
            rx_data[cnt] = RxBuffer[RxRptr++];
            cnt++;
            if (cnt == EP1IN_SIZE) break;
        }
        //键盘数据验证并处理
        if(rx_data[0] == 0x59 && rx_data[1] == 0x59){
            if(rx_data[2] == 0x01){
                if(rx_data[13] == 0x43 && rx_data[14] == 0x47){
                    EEPROM_Write(rx_data);
                    USB_CDC_send("已成功设置\n");
                }else if(rx_data[2] == 0x00){
                    EEPROM_Read();
                    USB_CDC_send("读取成功\n");
                }
            }else{
                USB_CDC_send("格式不正确:帧尾不对\n");
            }
        }else{
            USB_CDC_send("格式不正确:帧头不对\n");
        }
	}
	
    if (UsbOutBusy){
        IE2 &= ~0x80;   //EUSB = 0;
        if (RxWptr - RxRptr < 256 - EP1OUT_SIZE)
        {
            UsbOutBusy = 0;
            usb_write_reg(INDEX, 3);
            usb_write_reg(OUTCSR1, 0);
        }
        IE2 |= 0x80;    //EUSB = 1;
    }
}
